package org.hypik.test.jboss.eap7.server.timer;

import org.hypik.test.jboss.eap7.server.ITestService;
import org.slf4j.Logger;

import java.io.Serializable;

import javax.ejb.DependsOn;
import javax.ejb.EJB;
import javax.ejb.Local;
import javax.ejb.Singleton;
import javax.ejb.Timeout;
import javax.ejb.Timer;
import javax.inject.Inject;

@Singleton
@DependsOn({"TestService"})
@Local(IProducerTimer.class)
public class ProducerTimer extends AbstractTimer implements Serializable,
    IProducerTimer {

  /**
   * serial uid.
   */
  private static final long    serialVersionUID = -4426842701462966210L;

  public ProducerTimer() {
    super(1000);
  }

  @Inject
  private Logger               logger;

  @EJB
  private ITestService service;

  @Override
  @Timeout
  public void produce(Timer timer) {
    try {
      service.produce();
    } finally {
      createTimer();
    }
  }

}
